import entity
import bullet
import projection
import vector

class player(entity.entity):
    def __init__(self, pos, image, camerax, group, bulletgroup):
        entity.entity.__init__(self, pos, image, camerax)
        self.attackspeed = 500
        self.projectspeed = 3000
        self.sinceLastAttack = 501
        self.projected = False
        self.sinceProject = 3001
        self.projecting = False
        self.spriteGroup = group
        self.bulletGroup = bulletgroup
        self.projection = None
        self.vector = None
        self.health = 100
        self.lastHit = 3001
        self.invinceTime = 3000
        
    def attack(self, camerax):
        if self.sinceLastAttack > self.attackspeed and not self.projecting:
            if self.direction == entity.LEFT:
                pos = (self.pos.left - 10, self.pos.centery - 20)
            else:
                pos = (self.pos.right, self.pos.centery - 20)
                
            b = bullet.bullet(pos, self.direction, camerax, self.bulletGroup)
            self.sinceLastAttack = 0
            
    def update(self, camerax, elapsed):
        if not self.projected:
            entity.entity.update(self)
            self.sinceLastAttack += elapsed
                
        self.sinceProject += elapsed
        if self.sinceProject > self.projectspeed:
            self.projecting = False
        else:
            self.projecting = True
        
        self.lastHit += elapsed
            
    def project(self):
        if self.sinceProject > self.projectspeed:
            if self.projected:
                print 'unproject'
                self.projected = False
                self.sinceProject = 0
                self.projection.kill()
                self.projection.bullets.remove()
            else:
                print 'project'
                self.projected = True
                self.sinceProject = 0
                self.vector = vector.vec2d(self.rect.centerx, self.rect.centery)
                self.projection = projection.projection(self)
    
    def hit(self, damage):
        if self.lastHit > self.invinceTime:
            self.health -= damage
            
            if self.health <= 0:
                self.kill()
                self.health = 0
            else:
                self.lastHit = 0