import pygame
import data
import vector
import projectionBullet

class projection(pygame.sprite.Sprite):
    def __init__(self, player):
        pygame.sprite.Sprite.__init__(self)
        
        self.player = player
        self.image = data.loadimage('projection')
        self.image.set_colorkey((0,0,0))
        self.rect = self.image.get_rect()
        self.rect.left = self.player.rect.left + 50
        self.rect.top = self.player.rect.top - 50
        self.vector = vector.vec2d((self.rect.centerx, self.rect.centery))
        self.player.spriteGroup.add(self)
        self.velocity = 4
        self.vec = self.player.vector - self.vector
        self.normVec = self.vec.normalized()
        self.perpVec = self.vec.perpendicular_normal()
        self.lastAttack = 0
        self.attackSpeed = 500
        self.bullets = pygame.sprite.Group()
        
    def moveRight(self):
        self.vector.x += self.velocity
        
        if self.vector.get_distance(self.player.vector) > 200:
            self.vector.x -= self.velocity
            if self.vector.y > self.player.vector.y:
                self.moveUp()
            else:
                self.moveDown()
            
    def moveLeft(self):
        self.vector.x -= self.velocity
        
        if self.vector.get_distance(self.player.vector) > 200:
            self.vector.x += self.velocity
            if self.vector.y > self.player.vector.y:
                self.moveUp()
            else:
                self.moveDown()
        
    def moveUp(self):
        self.vector.y -= self.velocity
        
        if self.vector.get_distance(self.player.vector) > 200:
            self.vector.y += self.velocity
            if self.vector.x > self.player.vector.x:
                self.moveLeft()
            else:
                self.moveRight()
                
    def moveDown(self):
        self.vector.y += self.velocity
        
        if self.vector.get_distance(self.player.vector) > 200:
            self.vector.y -= self.velocity
            if self.vector.x > self.player.vector.x:
                self.moveLeft()
            else:
                self.moveRight()
    
    def midPoint(self):
        midx = (self.player.vector.x + self.vector.x) / 2
        midy = (self.player.vector.y + self.vector.y) / 2
        return (midx, midy)
    
    def update(self, elapsed):
        self.rect.centerx = self.vector.x
        self.rect.centery = self.vector.y
        
        vec = self.player.vector - self.vector
        self.normVec = vec.normalized()
        self.perpVec = vec.perpendicular_normal()
        
        self.bullets.update(elapsed)
        self.lastAttack += elapsed
        
    def attack(self, pos):
        if self.lastAttack > self.attackSpeed:
            b = projectionBullet.projectionBullet(self.vector, vector.vec2d(pos))
            self.bullets.add(b)
            
            self.lastAttack = 0